// WaitForAsyncOperationDialog.cpp : implementation file
//

#include "stdafx.h"
#include "ModalState.h"
#include "WaitForAsyncOperationDialog.h"


// CWaitForAsyncOperationDialog dialog

IMPLEMENT_DYNAMIC(CWaitForAsyncOperationDialog, CDialog)

CWaitForAsyncOperationDialog::CWaitForAsyncOperationDialog(CWnd* pParent, AsyncOperation *pAsyncOperation)
	: CDialog(CWaitForAsyncOperationDialog::IDD, pParent), m_pAsyncOperation(pAsyncOperation)
{

}

CWaitForAsyncOperationDialog::~CWaitForAsyncOperationDialog()
{
}

void CWaitForAsyncOperationDialog::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BOOL CWaitForAsyncOperationDialog::OnInitDialog()
{
	AfxBeginThread(_AsyncOperationThreadProc, this);
	return TRUE;
}

/* static */
UINT AFX_CDECL CWaitForAsyncOperationDialog::_AsyncOperationThreadProc(LPVOID pParam)
{
	CWaitForAsyncOperationDialog *pThis = static_cast<CWaitForAsyncOperationDialog *>(pParam);
	return pThis->AsyncOperationThreadProc();
}

UINT AFX_CDECL CWaitForAsyncOperationDialog::AsyncOperationThreadProc()
{
	PostMessage(WM_ASYNC_OPERATION_STARTED);
	m_pAsyncOperation->Execute();
	PostMessage(WM_ASYNC_OPERATION_COMPLETED);
	return 0;
}

BEGIN_MESSAGE_MAP(CWaitForAsyncOperationDialog, CDialog)
	ON_MESSAGE(WM_ASYNC_OPERATION_STARTED, OnAsyncOperationStarted)
	ON_MESSAGE(WM_ASYNC_OPERATION_COMPLETED, OnAsyncOperationCompleted)
END_MESSAGE_MAP()

LRESULT CWaitForAsyncOperationDialog::OnAsyncOperationStarted(WPARAM wParam, LPARAM lParam)
{
	return 0;
}

LRESULT CWaitForAsyncOperationDialog::OnAsyncOperationCompleted(WPARAM wParam, LPARAM lParam)
{
	EndDialog(IDOK);
	return 0;
}

// CWaitForAsyncOperationDialog message handlers
