#pragma once

class AsyncOperation
{
public:
	virtual void Execute() = 0;
};

class WasteTime : public AsyncOperation
{
public:
	virtual void Execute()
	{
		Sleep(10000);
	}
};


// CWaitForAsyncOperationDialog dialog

class CWaitForAsyncOperationDialog : public CDialog
{
	// See http://blogs.msdn.com/oldnewthing/archive/2006/09/25/770536.aspx
	static const UINT WM_ASYNC_OPERATION_STARTED = WM_APP + 42;
	static const UINT WM_ASYNC_OPERATION_COMPLETED = WM_APP + 43;

	AsyncOperation *m_pAsyncOperation;

	DECLARE_DYNAMIC(CWaitForAsyncOperationDialog)

public:
	CWaitForAsyncOperationDialog(CWnd* pParent, AsyncOperation *pAsyncOperation);
	virtual ~CWaitForAsyncOperationDialog();

// Dialog Data
	enum { IDD = IDD_WAITFORASYNCOPERATION };

protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	virtual BOOL OnInitDialog();

	DECLARE_MESSAGE_MAP()

	LRESULT OnAsyncOperationStarted(WPARAM wParam, LPARAM lParam);
	LRESULT OnAsyncOperationCompleted(WPARAM wParam, LPARAM lParam);

private:
	static UINT AFX_CDECL _AsyncOperationThreadProc(LPVOID pParam);
	UINT AFX_CDECL AsyncOperationThreadProc();
};
